/************************************
IIC.C IIC.Hһͬ빤
main()I_init();

****************************************/
#include "fx2.h"
#include "fx2regs.h"
#include<intrins.h>
#include<IIC.h>


#define  SCL PinSCL

#define SDA PinSDA

#define WRITE 0x32
#define READ 0x33
void d5us(){
	_nop_();_nop_();
	_nop_();_nop_();_nop_();
}

void I_ss(bit ss)
{	   //ss=1:start;SS=0;stop//
	OEA = OEA|0x03;
//	SCL=0;
	d5us();
	SDA=ss;
	d5us();
	 SCL=1;
	d5us();
	SDA=!ss;
	d5us();
//	SCL=0;
}
void I_init()
{
	I_ss(0);
}
void I_sendB(Uchar ch){
	Uchar chb;
	OEA = OEA|0x03;

	for(chb=0;chb<8;chb++){
		SCL=0;	
		d5us();
		if(ch&0x80)SDA=1;
		else SDA=0;
		ch=ch<<1;
		SCL=1;
		d5us();
	}
	SCL=0;
}
void ACK(bit ack)
{
	OEA = OEA|0x03;
	SDA=ack;
	d5us();
	SCL=1;
	d5us();
	SCL=0;
	d5us();
}
void watch()
{
	OEA = OEA|0x03;
	SDA=1;
	d5us();
	SCL=1;
	d5us();
	SCL=0;
	d5us();
}
Uchar I_write(Uchar waddr,Uchar num,Uchar *pra)
{				  
	Uchar i;

	waddr = (waddr << 1) ;
	EA=0;
	I_ss(1);
	I_sendB(waddr);
	#if 0
	watch();
	I_sendB(waddr);
	#endif
	watch();
	 for(i=0;i<num;i++)
	 {
		 I_sendB(pra[i]);
		 watch();
	 }
#ifdef __DEBUG_WITH_USB__
	pra[i]=waddr;
#endif
	 I_ss(0);
	 d5us();d5us();
	 EA=1;
	return I2C_OK;
}
Uchar I_receiveB(){
	Uchar read,i2;
	read=0;

	OEA = OEA&0xFD;
	for(i2=0;i2<8;i2++){		
		SDA=1;
		d5us();
		SCL=1;
		d5us();
		read<<=1;
		if(SDA)read++;		
		d5us();
		SCL=0;
		d5us();
	}
	return(read);
}
Uchar I_read(Uchar raddr,Uchar rnum,Uchar *sto)
{
	Uchar i3;
	Uchar waddr;
	Uchar ret;
	EA=0;
	raddr = (raddr << 1)| 0x01 ;
	waddr = raddr << 1;
	#if 0
	I_ss(1);
	I_sendB(waddr);
	watch();
	I_sendB(sto[0]);
	watch();
	I_ss(0);
	I_ss(1);
	I_sendB(raddr);
	watch();
	#else
	I_ss(1);
	I_sendB(raddr);
	watch();
	#endif
	for(i3=0;i3<rnum;i3++){
		sto[i3]=I_receiveB();
		if(i3<rnum-1)ACK(0);  
	}

#ifdef __DEBUG_WITH_USB__
	sto[i3]=raddr;
#endif
	
	SDA=1;
	d5us();
	SCL=1;
	d5us();
	SCL=0;
	d5us();
	I_ss(0);
	EA=1;
	ret = I2C_BERROR;
	for(i3=0;i3<rnum;i3++){
		if(sto[i3]!=0xff)
		{
			ret = I2C_OK;
		}
	}
	return ret;
}


