/*
 ## Cypress Antioch Firmware:
 ## USB Module source file (cyanfwusb.c)
 ## ===========================
 ##
 ##  Copyright Cypress Semiconductor Corporation, 2006-2007,
 ##  All Rights Reserved
 ##  UNPUBLISHED, LICENSED SOFTWARE.
 ##
 ##  CONFIDENTIAL AND PROPRIETARY INFORMATION
 ##  WHICH IS THE PROPERTY OF CYPRESS.
 ##
 ##  Use of this file is governed
 ##  by the license agreement included in the file
 ##
 ##     <install>/license/license.txt
 ##
 ##  where <install> is the Cypress software
 ##  installation root directory path.
 ##
 ## ===========================
*/
#define DBG

extern int gvalue;
#ifdef DBG
extern
bit I2CWrite(BYTE i2cAddr, BYTE sub_type, WORD addr, BYTE len, BYTE *write_dat);

extern
bit I2CRead(BYTE i2cAddr, BYTE sub_type, WORD addr, BYTE len, BYTE *read_dat);
#else
extern
bit I2CWrite(BYTE i2cAddr, WORD addr, BYTE write_dat);

extern
bit I2CRead(BYTE i2cAddr, WORD addr, BYTE *read_dat);
#endif

extern void
GPIO_Configure_PortA (int pin_number, bit Output);

extern void
GPIO_Configure_PortB (int pin_number, bit Output);

extern void
GPIO_Configure_PortC (int pin_number, bit Output);

extern void
GPIO_Configure_PortD (int pin_number, bit Output);

extern void
GPIO_Configure_PortE (int pin_number, bit Output);

extern void
GPIO_Write_PortA (int pin_number, bit value);

extern void
GPIO_Write_PortB (int pin_number, bit value);

extern void
GPIO_Write_PortC (int pin_number, bit value);

extern void
GPIO_Write_PortD (int pin_number, bit value);

extern void
GPIO_Write_PortE (int pin_number, bit value);

extern bit 
GPIO_Read_PortA(int pin_number);

extern bit 
GPIO_Read_PortB(int pin_number);

extern bit 
GPIO_Read_PortC(int pin_number);
extern bit 

GPIO_Read_PortD(int pin_number);

extern bit 
GPIO_Read_PortE(int pin_number);

extern bit GPIO_Read_PortB(int pin_number);
extern bit GPIO_Read_PortC(int pin_number);
extern bit GPIO_Read_PortD(int pin_number);
extern bit GPIO_Read_PortE(int pin_number);




