/************************************
IIC.C IIC.Hһͬ빤
main()I_init();

****************************************/
#include "fx2.h"
#include "fx2regs.h"
#include<intrins.h>
#include "i2c_sw.h"


#define  SCL_R PinSDA
#define SDA_R PinSCL

// Pin swapped
//#define SCL_R PinSCL
//#define SDA_R PinSDA


void d5us_R(){
	_nop_();_nop_();
	_nop_();_nop_();_nop_();
}

void I_ss_R(bit ss)
{
#if 0
	   //ss=1:start;SS=0;stop//
	OEA = OEA|0x03;
//	SCL_R=0;
	d5us_R();
	SDA_R=ss;
	d5us_R();
	SCL_R=1;
	d5us_R();
	SDA_R=!ss;
	d5us_R();
//	SCL_R=0;
#endif
}
void I_init_R()
{
	I_ss_R(0);
}
void I_sendB_R(Uchar ch){
#if 0
	Uchar chb;
	OEA = OEA|0x03;

	for(chb=0;chb<8;chb++){
		SCL_R=0;	
		d5us_R();
		if(ch&0x80)SDA_R=1;
		else SDA_R=0;
		ch=ch<<1;
		SCL_R=1;
		d5us_R();
	}
	SCL_R=0;
#endif
}
void ACK_R(bit ack)
{
#if 0
	OEA = OEA|0x03;
	SDA_R=ack;
	d5us_R();
	SCL_R=1;
	d5us_R();
	SCL_R=0;
	d5us_R();
#endif
}
void watch_R()
{
#if 0
//	OEA = OEA|0x03;
	OEA = OEA & 0xfe;
	SDA_R=1;
	d5us_R();
	SCL_R=1;
	d5us_R();
	SCL_R=0;
	OEA = OEA|0x03;
	d5us_R();
#endif
}
Uchar I_write_R(Uchar waddr,Uchar num,Uchar *pra)
{
#if 0				  
	Uchar i;

	waddr = (waddr << 1) ;
	EA=0;
	I_ss_R(1);
	I_sendB_R(waddr);
	#if 0
	watch_R();
	I_sendB_R(waddr);
	#endif
	watch_R();
	 for(i=0;i<num;i++)
	 {
		 I_sendB_R(pra[i]);
		 watch_R();
	 }
#ifdef __DEBUG_WITH_USB__
	pra[i]=waddr;
#endif
	 I_ss_R(0);
	 d5us_R();d5us_R();
	 EA=1;
	return I2C_OK;
#endif
}
Uchar I_receiveB_R(){
	Uchar read,i2;
#if 0
	read=0;

	OEA = OEA&0xFE;
	for(i2=0;i2<8;i2++){		
		SDA_R=1;
		d5us_R();
		SCL_R=1;
		d5us_R();
		read<<=1;
		if(SDA_R)read++;		
		d5us_R();
		SCL_R=0;
		d5us_R();
	}
#endif
	return(read);
}
Uchar I_read_R(Uchar raddr,Uchar rnum,Uchar *sto)
{
	Uchar ret;
#if 0
	Uchar i3;
	Uchar waddr;


	EA=0;
	raddr = (raddr << 1)| 0x01 ;
	waddr = raddr << 1;



	waddr = (waddr << 1) ;
	EA=0;
	I_ss_R(1);
	I_sendB_R(0);
	watch_R();
	I_sendB_R(0xFD);
	watch_R();
	I_ss_R(0);
	d5us_R();d5us_R();
 	EA=1;




	#if 0
	I_ss_R(1);
	I_sendB_R(waddr);
	watch_R();
	I_sendB_R(sto[0]);
	watch_R();
	I_ss_R(0);
	I_ss_R(1);
	I_sendB_R(raddr);
	watch_R();
	#else
	I_ss_R(1);
	I_sendB_R(raddr);
	watch_R();
	#endif
	for(i3=0;i3<rnum;i3++){
		sto[i3]=I_receiveB_R();
		if(i3<rnum-1)ACK_R(0);  
	}

#ifdef __DEBUG_WITH_USB__
	sto[i3]=raddr;
#endif
	
	SDA_R=1;
	d5us_R();
	SCL_R=1;
	d5us_R();
	SCL_R=0;
	d5us_R();
	I_ss_R(0);
	EA=1;
	ret = I2C_BERROR;
	for(i3=0;i3<rnum;i3++){
		if(sto[i3]!=0xff)
		{
			ret = I2C_OK;
		}
	}
#endif
	return ret;
}


